<?php

function query_user_info($user_id = 0, $where = '', $user_ids = array())
{
	global $db, $auth, $phpEx, $cache, $phpbb_root_path, $user, $config;

	if (!function_exists('get_user_rank'))
	{
		include_once($phpbb_root_path . 'includes/functions_display.' . $phpEx);
	}
	$ranks = $cache->obtain_ranks();

	$data = array();

	if ($user_id <> 0)
	{
		$sql = 'SELECT *
			FROM ' . USERS_TABLE . '
			WHERE user_id = ' . $user_id;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		// Grab ranks
		get_user_rank($row['user_rank'], $row['user_posts'], $rank['title'], $rank['image'], $rank['image_src']);

		$data = $row;

		$data = array_merge($data, array(
			'user_avatar_full'			=> get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']),
			'username_full'				=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
			'user_rank_title'			=> $rank['title'],
			'user_rank_image'			=> $rank['image'],
			'user_rank_image_src'		=> $rank['image_src'],
			'user_joined'				=> $user->format_date($row['user_regdate'], false, true),
			'user_pm_link'				=> ($config['allow_privmsg'] && $auth->acl_get('u_sendpm') && ($row['user_allow_pm'] || $auth->acl_gets('a_', 'm_') || $auth->acl_getf_global('m_'))) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=pm&amp;mode=compose&amp;u=' . $row['user_id']) : '',
			'user_email_link'			=> ($row['user_allow_viewemail']) ? (($config['board_email_form'] && $config['email_enable']) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=email&amp;u=$poster_id") : ((($config['board_hide_emails'] && !$auth->acl_get('a_email')) ? '' : 'mailto:' . $row['user_email']))) : '',
			'user_msnm_link'			=> ($row['user_msnm'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=msnm&amp;u=$user_id") : '',
			'user_icq_link'				=> ($row['user_icq']) ? 'http://www.icq.com/people/webmsg.php?to=' . $row['user_icq'] : '',
			'user_yim_link'				=> ($row['user_yim']) ? 'http://edit.yahoo.com/config/send_webmesg?.target=' . urlencode($row['user_yim']) . '&amp;.src=pg' : '',
			'user_aim_link'				=> ($row['user_aim'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=aim&amp;u=$user_id") : '',
			'user_jabber_link'			=> ($row['user_jabber'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=jabber&amp;u=$user_id") : '',
	
			'user_viewprofile'			=> append_sid($phpbb_root_path . 'memberlist.' . $phpEx, 'mode=viewprofile&u=' . $user_id),
		));
	}
	else if (is_array($user_ids) && sizeof($user_ids))
	{
		$sql = 'SELECT *
			FROM ' . USERS_TABLE . '
			WHERE ' . $db->sql_in_set('user_id', $user_ids, false, true);
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			// Grab ranks
			get_user_rank($row['user_rank'], $row['user_posts'], $rank['title'], $rank['image'], $rank['image_src']);

			$data[$user_id] = $row;

			$data[$user_id] = array_merge($data[$user_id], array(
				'user_avatar_full'			=> get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']),
				'username_full'				=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
				'user_rank_title'			=> $rank['title'],
				'user_rank_image'			=> $rank['image'],
				'user_rank_image_src'		=> $rank['image_src'],
				'user_joined'				=> $user->format_date($row['user_regdate'], false, true),
				'user_pm_link'				=> ($config['allow_privmsg'] && $auth->acl_get('u_sendpm') && ($row['user_allow_pm'] || $auth->acl_gets('a_', 'm_') || $auth->acl_getf_global('m_'))) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=pm&amp;mode=compose&amp;u=' . $row['user_id']) : '',
				'user_email_link'			=> ($row['user_allow_viewemail']) ? (($config['board_email_form'] && $config['email_enable']) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=email&amp;u=$poster_id") : ((($config['board_hide_emails'] && !$auth->acl_get('a_email')) ? '' : 'mailto:' . $row['user_email']))) : '',
				'user_msnm_link'			=> ($row['user_msnm'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=msnm&amp;u=$user_id") : '',
				'user_icq_link'				=> ($row['user_icq']) ? 'http://www.icq.com/people/webmsg.php?to=' . $row['user_icq'] : '',
				'user_yim_link'				=> ($row['user_yim']) ? 'http://edit.yahoo.com/config/send_webmesg?.target=' . urlencode($row['user_yim']) . '&amp;.src=pg' : '',
				'user_aim_link'				=> ($row['user_aim'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=aim&amp;u=$user_id") : '',
				'user_jabber_link'			=> ($row['user_jabber'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=jabber&amp;u=$user_id") : '',
		
				'user_viewprofile'			=> append_sid($phpbb_root_path . 'memberlist.' . $phpEx, 'mode=viewprofile&u=' . $user_id),
			));
		}
		$db->sql_freeresult($result);
	}
	else
	{
		if ($where == '')
		{
			$where = '1=0';
		}
		$sql = 'SELECT *
			FROM ' . USERS_TABLE . '
			WHERE ' . $where;
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			// Grab ranks
			get_user_rank($row['user_rank'], $row['user_posts'], $rank['title'], $rank['image'], $rank['image_src']);

			$data[$user_id] = $row;

			$data[$user_id] = array_merge($data[$user_id], array(
				'user_avatar_full'			=> get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']),
				'username_full'				=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
				'user_rank_title'			=> $rank['title'],
				'user_rank_image'			=> $rank['image'],
				'user_rank_image_src'		=> $rank['image_src'],
				'user_joined'				=> $user->format_date($row['user_regdate'], false, true),
				'user_pm_link'				=> ($config['allow_privmsg'] && $auth->acl_get('u_sendpm') && ($row['user_allow_pm'] || $auth->acl_gets('a_', 'm_') || $auth->acl_getf_global('m_'))) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=pm&amp;mode=compose&amp;u=' . $row['user_id']) : '',
				'user_email_link'			=> ($row['user_allow_viewemail']) ? (($config['board_email_form'] && $config['email_enable']) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=email&amp;u=$poster_id") : ((($config['board_hide_emails'] && !$auth->acl_get('a_email')) ? '' : 'mailto:' . $row['user_email']))) : '',
				'user_msnm_link'			=> ($row['user_msnm'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=msnm&amp;u=$user_id") : '',
				'user_icq_link'				=> ($row['user_icq']) ? 'http://www.icq.com/people/webmsg.php?to=' . $row['user_icq'] : '',
				'user_yim_link'				=> ($row['user_yim']) ? 'http://edit.yahoo.com/config/send_webmesg?.target=' . urlencode($row['user_yim']) . '&amp;.src=pg' : '',
				'user_aim_link'				=> ($row['user_aim'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=aim&amp;u=$user_id") : '',
				'user_jabber_link'			=> ($row['user_jabber'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=jabber&amp;u=$user_id") : '',
		
				'user_viewprofile'			=> append_sid($phpbb_root_path . 'memberlist.' . $phpEx, 'mode=viewprofile&u=' . $user_id),
			));
		}
		$db->sql_freeresult($result);
	}

	return $data;
}

?>